#!/usr/bin/python

#####################################
# Some usefull logging methods
# Author: Aron Schneider
#####################################

import logging
import time
import traceback

def start():

    # ******* SETTINGS ********** #
    path = "/home/pi/krull/logs/"

    # ******* SYSTEM ********** #
    filename = time.strftime("log_%Y-%m-%d_%H-%M-%S", time.gmtime())
    logging.basicConfig(format='%(levelname)s: %(message)s', filename=path+filename, level=logging.DEBUG)

    global starttime
    starttime = time.time()
    global player
    player = 0
    global turn
    turn = 1

def log(type, cat, msg):
   logging.info(makestr(type, cat, msg))

def logOld(type, msg, printing=True):
    logging.info(makestr(type, msg, printing))

def warning(msg):
    logging.warning(makestr("system", "warning", msg))

def error(msg):
    logging.error(makestr("system", "error", msg))

def exception():
    logging.error(makestr("system", "error", str(traceback.format_exc())))

def debug(msg):
    logging.info(makestr("system", "debug", msg))

def makestr(type, cat, msg):
    global player
    global turn
    s = seconds()
    logstring = s+" "+str(player)+" "+str(turn)+" "+str(type)+" "+str(cat)+" "+str(msg)
    printstring = s+" ["+type+"] "+cat+": "+str(msg)
    print printstring
    return logstring

def seconds():
    global starttime
    return str(int(round(time.time()-starttime)))

def setPlayer(p):
    global player
    player = p

def nextTurn():
    global turn
    turn += 1