# !/usr/bin/python

#####################################
# Mouth of Karsten Krull - Audio Output
# Author: Aron Schneider
#####################################

import pygame
import random
import log

class Speaker():

    def __init__(self):

        # ******* SETTINGS ********** #
        self.logtype = "speaker"

        ########### Don't touch ####################
        pygame.mixer.init(frequency=22050, size=-16, channels=2, buffer=4096) #256
        self.chan = pygame.mixer.Channel(0)

        ############ SOUND FILES ###################
        self.messages = dict(
            game_test = Messsage(["6b"]),

            game_wakeup = Messsage(["1", "2", "3", "4"]),
            game_firstreaction = Messsage(["5", "6", "7", "8", "9"]),
            game_explanation = Messsage(["10", "11", "12", "13", "14"]),

            game_end1 = Messsage(["15"]),
            game_end2 = Messsage(["17"]),
            game_end3 = Messsage(["18"]),
            game_end4 = Messsage(["19"]),

            login_request = Messsage(["264", "265", "266", "267", "268", "269", "270"]),
            login_wrongPlayer = Messsage(["444", "445", "446"]),
            login_mouthFull = Messsage(["261", "262", "263"]),

            login_welcomPlayer1contact1 = Messsage(["271", "272", "273"]),
            login_welcomPlayer1contact2 = Messsage(["274", "275", "276"]),
            login_welcomPlayer1contact3 = Messsage(["277", "278", "279"]),
            login_welcomPlayer1contact4 = Messsage(["280", "281", "282"]),
            login_welcomPlayer1contact5 = Messsage(["283", "284", "285"]),
            login_welcomPlayer1contact6 = Messsage(["286", "287"]),

            login_welcomPlayer2contact1 = Messsage(["288", "289", "290"]),
            login_welcomPlayer2contact2 = Messsage(["291", "292", "293"]),
            login_welcomPlayer2contact3 = Messsage(["294", "295", "296"]),
            login_welcomPlayer2contact4 = Messsage(["297", "298", "299"]),
            login_welcomPlayer2contact5 = Messsage(["300", "301", "302"]),
            login_welcomPlayer2contact6 = Messsage(["303", "304"]),

            login_welcomPlayer3contact1 = Messsage(["305", "306", "307"]),
            login_welcomPlayer3contact2 = Messsage(["308", "309", "310"]),
            login_welcomPlayer3contact3 = Messsage(["311", "312", "313"]),
            login_welcomPlayer3contact4 = Messsage(["314", "315", "316"]),
            login_welcomPlayer3contact5 = Messsage(["317", "318", "319"]),
            login_welcomPlayer3contact6 = Messsage(["320", "321"]),

            login_welcomPlayer4contact1 = Messsage(["322", "323", "324"]),
            login_welcomPlayer4contact2 = Messsage(["325", "326", "327"]),
            login_welcomPlayer4contact3 = Messsage(["328", "329", "330"]),
            login_welcomPlayer4contact4 = Messsage(["331", "332", "333"]),
            login_welcomPlayer4contact5 = Messsage(["334", "335", "336"]),
            login_welcomPlayer4contact6 = Messsage(["337", "338"]),

            login_welcomCondition_bored = Messsage(["339", "340", "341"]),
            login_welcomCondition_headache = Messsage(["342", "343", "344"]),
            login_welcomCondition_sick = Messsage(["345", "346", "347"]),
            login_welcomCondition_toothache = Messsage(["348", "349", "350"]),
            login_welcomCondition_scale = Messsage(["351", "352", "353"]),
            login_welcomCondition_pain = Messsage(["354", "355"]),
            login_welcomCondition_hungry = Messsage(["356", "357", "358"]),
            login_welcomCondition_thirsty = Messsage(["359", "360", "361"]),
            login_welcomCondition_hickup = Messsage(["3623", "363", "364"]),

            complaining_normal = Messsage(["21", "22", "23", "24"]),

            complaining_boredAny = Messsage(["25", "26", "27", "28", "29", "35", "36", "37"]),
            complaining_boredThrow = Messsage(["38", "39", "40", "41", "42", "43", "44"]),
            complaining_boredSing = Messsage(["379", "380", "381", "382", "383"]),
            complaining_boredSinging = Messsage(["384", "385", "386", "387", "388"]),
            complaining_boredLight = Messsage(["365", "366", "367"]),

            complaining_headache1 = Messsage(["48", "49", "50"]),
            complaining_headache2 = Messsage(["51", "52", "53"]),
            complaining_headache3 = Messsage(["54", "55"]),

            complaining_headacheNoisy1 = Messsage(["395", "396", "397"]),
            complaining_headacheNoisy2 = Messsage(["398", "399", "400"]),
            complaining_headacheNoisy3 = Messsage(["401", "402", "403"]),

            complaining_headacheLight1 = Messsage(["370", "371", "372"]),
            complaining_headacheLight2 = Messsage(["373", "374", "375"]),
            complaining_headacheLight3 = Messsage(["376", "377", "378"]),

            complaining_sick1 = Messsage(["59", "60", "61"]),
            complaining_sick2 = Messsage(["62", "63", "64"]),
            complaining_sick3 = Messsage(["65", "65", "67", "68"]),

            complaining_toothache1 = Messsage(["74", "75", "76", "77", "78"]),
            complaining_toothache2 = Messsage(["79", "79", "80", "81"]),
            complaining_toothache3 = Messsage(["82", "83", "84"]),

            complaining_scale1 = Messsage(["103", "104", "105", "106"]),
            complaining_scale2 = Messsage(["108", "110"]),
            complaining_scale3 = Messsage(["111", "112", "113", "114", "115"]),

            complaining_painRight = Messsage(["125", "126", "127", "137a"]),
            complaining_painLeft = Messsage(["128", "129", "130", "137b"]),
            complaining_painBack = Messsage(["131", "132", "133", "134"]),
            complaining_painHead = Messsage(["135", "136"]),

            complaining_hungry1 = Messsage(["145", "146", "147", "148", "149", "150", "151"]),
            complaining_hungry2 = Messsage(["152", "153", "154", "155", "156"]),
            complaining_hungry3 = Messsage(["157", "158", "159", "160"]),

            complaining_thirsty1 = Messsage(["161", "162", "163", "164", "165"]),
            complaining_thirsty2 = Messsage(["166", "167", "168"]),
            complaining_thirsty3 = Messsage(["169", "170", "171", "172", "173"]),

            complaining_hickup = Messsage(["185", "185a", "185b", "185c", "185d", "185e", "185f", "185g", "185h", "185i"]),
            complaining_hickup1 = Messsage(["174", "175", "176"]),
            complaining_hickup2 = Messsage(["177", "178", "179", "180"]),
            complaining_hickup3 = Messsage(["181", "182", "183", "184"]),

            handover_normal = Messsage(["408", "409", "410", "411", "412", "413", "414"]),
            handover_reminder = Messsage(["415", "416", "417", "418"]),
            handover_bored = Messsage(["423", "424", "425", "426"]),
            handover_headache = Messsage(["428", "429", "430"]),
            handover_sick = Messsage(["433", "434", "345"]),
            handover_hickup = Messsage(["441", "442"]),

            reaction_munching_normal = Messsage(["189", "190"]),
            reaction_munching_hungry = Messsage(["211", "212", "213"]),
            reaction_munching_hickup = Messsage(["185"]),

            reaction_food_normal = Messsage(["191", "192", "193", "194", "195"]),
            reaction_food_bored = Messsage(["196", "197"]),
            reaction_food_sick = Messsage(["198", "199", "200", "201", "202", "203", "204", "205", "206"]),
            reaction_food_toothache = Messsage(["207", "208", "209", "210"]),
            reaction_food_hungry = Messsage(["214", "215", "216", "217", "218", "219", "220", "221", "222", "223", "224"]),
            reaction_food_thirsty = Messsage(["225", "226", "227", "228"]),
            reaction_food_hickup = Messsage(["229", "230", "231"]),

            reaction_gulp_normal = Messsage(["232", "233", "234"]),
            reaction_gulp_hickup = Messsage(["185a"]),

            reaction_drink_normal = Messsage(["235", "236", "237"]),
            reaction_drink_bored = Messsage(["238", "239", "240"]),
            reaction_drink_sick = Messsage(["241", "242", "243", "244", "245"]),
            reaction_drink_toothache = Messsage(["246", "247"]),
            reaction_drink_hungry = Messsage(["248", "249", "250", "251"]),
            reaction_drink_thirsty = Messsage(["252", "253", "254", "255", "256", "257", "258"]),
            reaction_drink_hickup = Messsage(["259", "260"]),

            reaction_teeth = Messsage(["85", "86", "87", "88", "89", "90", "91", "92"]),
            reaction_teeth_solved = Messsage(["93", "94", "95", "96", "97", "98", "99", "100", "101", "102"]),

            reaction_scale = Messsage(["116", "118", "119", "120"]),
            reaction_scale_solved = Messsage(["121", "122", "123", "124"]),

            reaction_throw_normal = Messsage(["419", "420", "421", "422", "422a", "422b", "422c"]),
            reaction_throw_bored = Messsage(["45", "46", "47", "427"]),
            reaction_throw_headache = Messsage(["431", "432"]),
            reaction_throw_sick = Messsage(["436", "437", "438", "439", "440"]),
            reaction_throw_hickup = Messsage(["443"]),

            reaction_turned_wrong = Messsage(["137", "138", "139"]),
            reaction_turned_right = Messsage(["140", "141", "142", "143", "144"]),

            reaction_headache_solved = Messsage(["56", "57", "58"]),
            reaction_sick_solved = Messsage(["69", "70", "71", "72", "73"]),
            reaction_hickup_solved = Messsage(["186", "187", "188"]),
            reaction_bored_solved =  Messsage(["30", "31", "32", "33", "34"]),

            reaction_shout = Messsage(["404", "405", "406", "407"]),
            reaction_sing = Messsage(["389", "390", "391", "392", "393", "394"]),

            reaction_light = Messsage(["368", "369"]),
        )

    def speak(self, message, priority=False):

        if message in self.messages:
            line = self.messages[message].getLine()
            if line == "missing":
                log.warning("speaker empty message list: "+message)
            else:
                if priority:
                    self.chan.play(line)
                else:
                    self.chan.queue(line)
                cat, msg = message.split("_", 1)
                log.log(self.logtype, cat, msg)

        else:
            log.warning("speaker - message not found: "+message)

    def speaking(self):
        return self.chan.get_busy()

class Messsage():

    def __init__(self, lines):
        self.path =  '/home/pi/krull/Audio/'
        self.lines = []
        self.linesUsed = []
        for line in lines:
            self.lines.append(pygame.mixer.Sound(self.path + line + ".wav"))

    def getLine(self):
        if len(self.lines) != 0:
            # get random line from lines
            line = random.choice(self.lines)

            # move line to linesUsed
            self.linesUsed. append(line)
            self.lines.remove(line)

            # if lines empty - move linesUsed in lines
            if len(self.lines) == 0:
                for l in self.linesUsed:
                    self.linesUsed.remove(l)
                    self.lines.append(l)

            return line
        else:
            return "missing"

